import { FIRST_ARRAY_ELEMENT } from '@/constants/common';
import { Publication } from '@/types/models';
import { StandarizedPublication } from '@/types/publications';

interface Options {
  modelNameIdMap: Record<number, string>;
}

export const getStandarizedPublication = (
  publication: Publication,
  options: Options,
): StandarizedPublication => {
  const {
    publication: { article },
    elements,
  } = publication;
  const { modelNameIdMap } = options;
  const { title, authors, journal, year, pubmedId } = article;
  const mainElement = elements?.[FIRST_ARRAY_ELEMENT];

  return {
    pubmedId,
    journal,
    title,
    year: year ? `${year}` : '',
    authors: authors.join(','),
    modelName: mainElement ? modelNameIdMap[mainElement.modelId] : '',
    elementId: '', // TODO:
  };
};
